/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VDmFillgroupRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDmFillgroup extends TableImpl<VDmFillgroupRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dm_fillgroup</code>
     */
    public static final VDmFillgroup V_DM_FILLGROUP = new VDmFillgroup();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDmFillgroupRecord> getRecordType() {
        return VDmFillgroupRecord.class;
    }

    /**
     * The column <code>common_dd.v_dm_fillgroup.fk_element</code>.
     */
    public final TableField<VDmFillgroupRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_fillgroup.fill_group_id</code>.
     */
    public final TableField<VDmFillgroupRecord, Integer> FILL_GROUP_ID = createField(DSL.name("fill_group_id"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_fillgroup.fill_group_min</code>.
     */
    public final TableField<VDmFillgroupRecord, Integer> FILL_GROUP_MIN = createField(DSL.name("fill_group_min"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_fillgroup.fill_group_max</code>.
     */
    public final TableField<VDmFillgroupRecord, Integer> FILL_GROUP_MAX = createField(DSL.name("fill_group_max"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_fillgroup.fill_and_group_pk</code>.
     */
    public final TableField<VDmFillgroupRecord, Integer> FILL_AND_GROUP_PK = createField(DSL.name("fill_and_group_pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_dm_fillgroup.fill_and_group_lastchange</code>.
     */
    public final TableField<VDmFillgroupRecord, LocalDateTime> FILL_AND_GROUP_LASTCHANGE = createField(DSL.name("fill_and_group_lastchange"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.v_dm_fillgroup.fill_group_pk</code>.
     */
    public final TableField<VDmFillgroupRecord, Integer> FILL_GROUP_PK = createField(DSL.name("fill_group_pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_fillgroup.fill_group_lastchange</code>.
     */
    public final TableField<VDmFillgroupRecord, LocalDateTime> FILL_GROUP_LASTCHANGE = createField(DSL.name("fill_group_lastchange"), SQLDataType.LOCALDATETIME(6), this, "");

    private VDmFillgroup(Name alias, Table<VDmFillgroupRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDmFillgroup(Name alias, Table<VDmFillgroupRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dm_fillgroup" as  SELECT a.fk_element,
         a.group_id AS fill_group_id,
         b.min AS fill_group_min,
         b.max AS fill_group_max,
         a.pk AS fill_and_group_pk,
         a.lastchange AS fill_and_group_lastchange,
         b.pk AS fill_group_pk,
         b.lastchange AS fill_group_lastchange
        FROM (common_dd.t_core_element_hierarchy_and_group a
          LEFT JOIN common_dd.t_core_element_hierarchy_group b ON ((a.group_id = b.pk)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_fillgroup</code> table reference
     */
    public VDmFillgroup(String alias) {
        this(DSL.name(alias), V_DM_FILLGROUP);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_fillgroup</code> table reference
     */
    public VDmFillgroup(Name alias) {
        this(alias, V_DM_FILLGROUP);
    }

    /**
     * Create a <code>common_dd.v_dm_fillgroup</code> table reference
     */
    public VDmFillgroup() {
        this(DSL.name("v_dm_fillgroup"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDmFillgroup as(String alias) {
        return new VDmFillgroup(DSL.name(alias), this);
    }

    @Override
    public VDmFillgroup as(Name alias) {
        return new VDmFillgroup(alias, this);
    }

    @Override
    public VDmFillgroup as(Table<?> alias) {
        return new VDmFillgroup(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmFillgroup rename(String name) {
        return new VDmFillgroup(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmFillgroup rename(Name name) {
        return new VDmFillgroup(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmFillgroup rename(Table<?> name) {
        return new VDmFillgroup(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmFillgroup where(Condition condition) {
        return new VDmFillgroup(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmFillgroup where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmFillgroup where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmFillgroup where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmFillgroup where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmFillgroup where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmFillgroup where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmFillgroup where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmFillgroup whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmFillgroup whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
